---
title: Array.prototype.length
slug: Web/JavaScript/Reference/Global_Objects/Array/length
tags:
  - Array
  - JavaScript
  - Property
  - Reference
---
<div>{{JSRef}}</div>

<p>The <code><strong>length</strong></code> property of an object which is an instance of type <code>Array</code> sets or returns the number of elements in that array. The value is an unsigned, 32-bit integer that is always numerically greater than the highest index in the array.</p>

<div>{{EmbedInteractiveExample("pages/js/array-length.html","shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Description">Description</h2>

<p>The value of the <code>length</code> property is an integer with a positive sign and a value less than 2 to the 32nd power (2<sup>32</sup>).</p>

<pre class="brush: js notranslate">var namelistA = new Array(4294967296); //2 to the 32nd power<sup> = </sup>4294967296
var namelistC = new Array(-100) //negative sign

console.log(namelistA.length); //RangeError: Invalid array length
console.log(namelistC.length); //RangeError: Invalid array length

var namelistB = [];
namelistB.length = Math.pow(2,32)-1; //set array length less than 2 to the 32nd power
console.log(namelistB.length);

//4294967295
</pre>

<p>You can set the <code>length</code> property to truncate an array at any time. When you extend an array by changing its <code>length</code> property, the number of actual elements increases; for example, if you set <code>length</code> to 3 when it is currently 2, the array now contains 3 elements, which causes the third element to be a non-iterable empty slot.</p>

<pre class="brush: js notranslate">const arr = [1, 2];
console.log(arr);
// [ 1, 2 ]

arr.length = 5; // set array length to 5 while currently 2.
console.log(arr);
// [ 1, 2, &lt;3 empty items&gt; ]

arr.forEach(element =&gt; console.log(element));
// 1
// 2
</pre>

<p>As you can see, the <code>length</code> property does not necessarily indicate the number of defined values in the array. See also <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array#Relationship_between_length_and_numerical_properties" title="Relationship between length and numerical properties">Relationship between <code>length</code> and numerical properties</a>.</p>

<p>{{js_property_attributes(1, 0, 0)}}</p>

<div>
<ul>
 <li><code>Writable</code>: If this attribute set to <code>false</code>, the value of the property cannot be changed.</li>
 <li><code>Configurable</code>: If this attribute set to <code>false</code>, any attempts to delete the property or change its attributes (<code>Writable</code>, <code>Configurable</code>, or <code>Enumerable</code>) will fail.</li>
 <li><code>Enumerable</code>: If this attribute set to <code>true</code>, the property will be iterated over during <a href="/en-US/docs/Web/JavaScript/Reference/Statements/for">for</a> or <a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...in">for..in</a> loops.</li>
</ul>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Iterating_over_an_array">Iterating over an array</h3>

<p>In the following example, the array <code>numbers</code> is iterated through by looking at the <code>length</code> property. The value in each element is then doubled.</p>

<pre class="brush: js notranslate">var numbers = [1, 2, 3, 4, 5];
var length = numbers.length;
for (var i = 0; i &lt; length; i++) {
  numbers[i] *= 2;
}
// numbers is now [2, 4, 6, 8, 10]
</pre>

<h3 id="Shortening_an_array">Shortening an array</h3>

<p>The following example shortens the array <code>numbers</code> to a length of 3 if the current length is greater than 3.</p>

<pre class="brush: js notranslate">var numbers = [1, 2, 3, 4, 5];

if (numbers.length &gt; 3) {
  numbers.length = 3;
}

console.log(numbers); // [1, 2, 3]
console.log(numbers.length); // 3
</pre>

<h3 id="Create_empty_array_of_fixed_length">Create empty array of fixed length</h3>

<pre class="brush: js notranslate">var numbers = [];
numbers.length = 3;
console.log(numbers); // [undefined, undefined, undefined]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-properties-of-array-instances-length', 'Array.length')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("javascript.builtins.Array.length")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array")}}</li>
</ul>
